/*
    SDL_Go - a GUI for GnuGo    
    Copyright (C) 2000  Andreas Rver

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Homepage: http://www.rz.tu-ilmenau.de/~roever/SDL_Go
    Email: andreas_roever@yahoo.com
*/



#include "application.h"

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>

#include <assert.h>
#include <stdlib.h>

Application::Application() : Widget(NULL, Rect()), screen(NULL) {
  SDL_Init(SDL_INIT_VIDEO);  
  atexit(SDL_Quit);
  TTF_Init();
}
Application::~Application() {
  delete screen;
  done();
  SDL_Quit();
}
    
void Application::setVideoMode(Uint16 xRes, Uint16 yRes, Uint8 bpp) {
  screen = new ScreenSurface(xRes, yRes, bpp, false);
}
    
void Application::quit() { quitApplication = true; }
    
void Application::run() { 
  assert(screen != NULL);

  quitApplication = false;
  
  SDL_Event e;
  
  do {
    if (SDL_PollEvent(&e) > 0) {
      handleEvent(e);
    } else {
      e.type = SDL_USEREVENT;
      e.user.code = -1;
      handleEvent(e);
    } 
    SDL_Delay(10);
  } while (!quitApplication);
}

void Application::toggleFullscreen() {
  SDL_WM_ToggleFullScreen(screen->getSurface());
}