/*
    SDL_Go - a GUI for GnuGo    
    Copyright (C) 2000  Andreas Rver

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Homepage: http://www.rz.tu-ilmenau.de/~roever/SDL_Go
    Email: andreas_roever@yahoo.com
*/



/**
 * class that can take a picture or an image and fills a surface with
 * backgroundata the image can be tiled, the colors us used to fill
 * the background
 */

#ifndef BACKGROUND__H_
#define BACKGROUND__H_

#include "surface.h"
#include "rect.h"
#include "color.h"

#include <iostream.h>

class Background {

  public:
  
    /**
     * initializes the class with the values from the stream
     */
    Background(istream &in);
    
    /**
     * will delete the surface
     */
    ~Background();
    
    /**
     * will draw background in the rectangle area on dest
     */
    void draw(Surface &dest, const Rect &area);
    
  private:
  
    /**
     * either the background image or NULL
     */
    Surface *image;
    
    /**
     * if image is NULL this variables contains the background color
     */
    Color color;
};

#endif