/*
    SDL_Go - a GUI for GnuGo    
    Copyright (C) 2000  Andreas Rver

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Homepage: http://www.rz.tu-ilmenau.de/~roever/SDL_Go
    Email: andreas_roever@yahoo.com
*/


#include "color.h"

#include <assert.h>

int Color::trueColor;
SDL_Color *Color::palette;

Color::Color(istream &in) { 
  if (trueColor) {
    in.read(&r, 1); 
    in.read(&g, 1); 
    in.read(&b, 1); 
    a = 0;
  } else {
    in.read(&i, 1);
    lookupPalette();
  }
}
  
Color::operator SDL_Color() const { 
  SDL_Color c; 
  c.r = r; 
  c.g = g; 
  c.b = b; 
  return c; 
}
    
// always 256 colors
void Color::setPalette(SDL_Color *colors) {
  trueColor = false;
  palette = colors;
}
    
void Color::setTrueColor() {
  delete palette;
  trueColor = true;
}

void Color::lookupPalette() {
  assert(!trueColor);
  r = palette[i].r;
  g = palette[i].g;
  b = palette[i].b;
  a = 0;
}