/*
    SDL_Go - a GUI for GnuGo    
    Copyright (C) 2000  Andreas Rver

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Homepage: http://www.rz.tu-ilmenau.de/~roever/SDL_Go
    Email: andreas_roever@yahoo.com
*/



#include "point.h"
    
Point& Point::operator= (const Point& p) {
  x = p.x;
  y = p.y;
  return *this;
}
    
Point& Point::operator+= (const Point& p) { 
  x += p.x; 
  y += p.y;  
  return *this; 
}
    
Point& Point::operator-= (const Point& p) {
  x -= p.x;
  y -= p.y;
  return *this;
}

Point operator+ (const Point& p, const Point& q) { 
  return Point(p) += q; 
}

Point operator- (const Point& p, const Point& q) { 
  return Point(p) -= q; 
}

bool operator== (const Point &p, const Point &q) { 
  return (p.x == q.x) && (p.y == q.y); 
}

bool operator<= (const Point &p, const Point &q) { 
  return (p.x <= q.x) && (p.y <= q.y); 
}

bool operator>= (const Point &p, const Point &q) { 
  return (p.x >= q.x) && (p.y >= q.y); 
}

bool operator< (const Point &p, const Point &q) { 
  return (p.x < q.x) && (p.y < q.y); 
}

bool operator>(const Point &p, const Point &q) { 
  return (p.x > q.x) && (p.y > q.y); 
}
