/*
    SDL_Go - a GUI for GnuGo    
    Copyright (C) 2000  Andreas Rver

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Homepage: http://www.rz.tu-ilmenau.de/~roever/SDL_Go
    Email: andreas_roever@yahoo.com
*/



/**
 * encapsulated the coordinates of one point
 */

#ifndef POINT__H_
#define POINT__H_

#include <SDL/SDL.h>

class Point {
  public:
    Point() : x(0), y(0) {}
    Point(const Sint32 xp, const Sint32 yp) : x(xp), y(yp) {}
    Point(const Point &p) : x(p.x), y(p.y) {}
    ~Point() {};
    
    Sint32 getX() const { return x; }
    Sint32 getY() const { return y; }
    
    Point& operator= (const Point& p);
    
    Point& operator+= (const Point& p);
    
    Point& operator-= (const Point& p);

    friend Point operator+ (const Point& p, const Point& q);
    friend Point operator- (const Point& p, const Point& q);
    friend bool operator== (const Point &p, const Point &q);
    friend bool operator<= (const Point &p, const Point &q);
    friend bool operator>= (const Point &p, const Point &q);
    friend bool operator< (const Point &p, const Point &q);
    friend bool operator> (const Point &p, const Point &q);

  private:
  
    Sint32 x, y;
};

#endif
