/*
    SDL_Go - a GUI for GnuGo    
    Copyright (C) 2000  Andreas Rver

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Homepage: http://www.rz.tu-ilmenau.de/~roever/SDL_Go
    Email: andreas_roever@yahoo.com
*/



#include "pushbutton.h"

PushButton::PushButton(Widget *parent, const Rect &r, Uint8 com) :
  Widget(parent, r),
  command(com) {
  active = false;
}
 
bool PushButton::handleEvent(SDL_Event &e) {
  if ((e.type == SDL_MOUSEBUTTONDOWN) && 
      !active && 
      onWidget(Point(e.button.x, e.button.y))) {
    pressButton();
    pushed = true;
    active = true;
    return true;
  }
  if ((e.type == SDL_MOUSEBUTTONUP) && active) {
    if (pushed) {
      releaseButton();
      pushed = false;
    }
    if (onWidget(Point(e.button.x, e.button.y))) {
      SDL_Event e;
      e.type = SDL_USEREVENT;
      e.user.code = command;
      processEvent(e);
    }
    active = false;
    return true;
  }
  if ((e.type == SDL_MOUSEMOTION) && active) {
    if (onWidget(Point(e.motion.x, e.motion.y))) {
      if (!pushed) {
        pressButton();
	pushed = true;
	return true;
      }
    } else {
      if (pushed) {
        releaseButton();
	pushed = false;
	return true;
      }
    }
  }
  return false;
}