/*
    SDL_Go - a GUI for GnuGo    
    Copyright (C) 2000  Andreas Rver

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Homepage: http://www.rz.tu-ilmenau.de/~roever/SDL_Go
    Email: andreas_roever@yahoo.com
*/



/**
 * this is the button.
 */
 
#ifndef PUSHBUTTON__H_
#define PUSHBUTTON__H_
 
#include "widget.h"
 
class PushButton : public Widget {

  public:
    
    /**
     * assumes that the button is already painted in it's initial state (unpressed)
     */
    PushButton(Widget *parent, const Rect &r, Uint8 com);
    
    bool handleEvent(SDL_Event &e);
    
    /**
     * this function is called whenever the button needs to be painted
     * in a pressed state
     */
    virtual void pressButton() { }
    
    /**
     * this function is calles whenever you need to releas the button
     */
    virtual void releaseButton() { }
    
  private:
    
    Uint8 command;
    bool pushed;
    bool active;
};

#endif