/*
    SDL_Go - a GUI for GnuGo    
    Copyright (C) 2000  Andreas Rver

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Homepage: http://www.rz.tu-ilmenau.de/~roever/SDL_Go
    Email: andreas_roever@yahoo.com
*/



#include "screensurface.h"

ScreenSurface::ScreenSurface(int w, int h, int bitPerPixel, bool fullscreen):
  Surface(),
  fullsc(false) {

//  Uint32 flags = SDL_ANYFORMAT | SDL_HWSURFACE;
  Uint32 flags = SDL_SWSURFACE;

  if (fullscreen) flags |= SDL_FULLSCREEN;
  
  /* switch to video mode */
  
  sdlSurface = SDL_SetVideoMode(w, h, bitPerPixel, flags);
  
  if (sdlSurface == 0) {
    // FIXME: throw exception instead of exiting
    exit(2);
  }

  fullsc = (sdlSurface->flags & SDL_FULLSCREEN);
  
  format = new Pixelformat(sdlSurface->format->BytesPerPixel,
                           sdlSurface->format->Rmask,
			   sdlSurface->format->Gmask,
			   sdlSurface->format->Bmask);
			   
  maxCoord = Point(w - 1, h - 1);
}

void ScreenSurface::update() {
  SDL_UpdateRect(sdlSurface, 0, 0, 0, 0);
}
  
void ScreenSurface::update(const Rect& dest) {
  SDL_UpdateRect(sdlSurface, dest.getUpperLeft().getX(), dest.getUpperLeft().getY(), 
                 dest.width(), dest.height());
}

void ScreenSurface::toggleFullscreen() {
  SDL_WM_ToggleFullScreen(sdlSurface);
}