/*
    SDL_Go - a GUI for GnuGo    
    Copyright (C) 2000  Andreas Rver

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Homepage: http://www.rz.tu-ilmenau.de/~roever/SDL_Go
    Email: andreas_roever@yahoo.com
*/



/**
 * a surface that is situated on the screen
 */

#ifndef SCREENSURFACE__H_
#define SCREENSURFACE__H_

#include "surface.h"


class ScreenSurface : public Surface {

  public:

    ScreenSurface(int w, int h, int bitsPerPixel, bool fullscreen);
    ~ScreenSurface() {};

    /**
     * updates the whole screen to repesent the surface
     */
    void update();
    /**
     * updates only the given rectangle
     */
    void update(const Rect& dest);
  
    /**
     * toggles between fullscreen and windowed view
     */
    void toggleFullscreen();
    /**
     * returns tur, if the application is currently
     * running in fullscreen mode
     */
    bool fullscreen() const { return fullsc; }

  private:
  
    bool fullsc;
};

#endif



