/*
    SDL_Go - a GUI for GnuGo    
    Copyright (C) 2000  Andreas Rver

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Homepage: http://www.rz.tu-ilmenau.de/~roever/SDL_Go
    Email: andreas_roever@yahoo.com
*/



#include "sdlboard.h"
#include "point.h"
#include "vertex.h"

SDL_Board::SDL_Board(Widget *parent, const Rect &r, Datafile *dat) :
  Widget(parent, r) {
  data = dat;
  active = false;
}
    
bool SDL_Board::handleEvent(SDL_Event &e) {
  if ((e.type == SDL_MOUSEBUTTONDOWN) && !active) {
    Vertex v = data->getVertex(Point(e.button.x, e.button.y));
    if (v.isValid()) {
      active = true;
      position = v;
      return true;
    }
  }
  if ((e.type == SDL_MOUSEBUTTONUP) && active) {
    active = false;
    Vertex v = data->getVertex(Point(e.button.x, e.button.y));
    if (v == position) {
      SDL_Event e;
      e.type = SDL_USEREVENT;
      e.user.code = 11;
      e.user.data1 = new Vertex(v);
      processEvent(e);
      return true;
    }
  }
  return false;
}
    
