/*
    SDL_Go - a GUI for GnuGo    
    Copyright (C) 2000  Andreas Rver

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Homepage: http://www.rz.tu-ilmenau.de/~roever/SDL_Go
    Email: andreas_roever@yahoo.com
*/



/**
 * a button that is secially adapted for SDLGo.
 * it has special press and release functions that call the necessary
 * update-functions within the datafile object to
 * update the buttons
 */
 
#ifndef SDL_PUSHBUTTON__H_
#define SDL_PUSHBUTTON__H_
 
#include "pushbutton.h"
#include "widget.h"
#include "rect.h"
#include "datafile.h"

#include <SDL/SDL.h>

class SDL_PushButton : public PushButton {
  
  public:
  
    SDL_PushButton(Widget *parent, const Rect &r, Uint8 number, Datafile *dat);
    
    void pressButton();
    void releaseButton();
    
  private:
  
    Uint8 number;
    Datafile *data;
};

#endif