/*
    SDL_Go - a GUI for GnuGo    
    Copyright (C) 2000  Andreas Rver

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
    Homepage: http://www.rz.tu-ilmenau.de/~roever/SDL_Go
    Email: andreas_roever@yahoo.com
*/



/**
 * encapsulates a position on the board
 */
 
#include "vertex.h" 

Vertex::Vertex() : x(255), y(255) { };

Vertex::Vertex(Uint8 row, Uint8 col) : x(col), y(row) { }

bool Vertex::isValid() {
  return ((x != 255) && (y != 255));
}

ostream& operator<<(ostream& o, const Vertex& v) {
  if (v.x < 8) 
    o << char(v.x + int('A'));
  else
    o << char(v.x + int('B'));
  
  o << int(v.y + 1);
  
  return o;
}

istream& operator>>(istream& i, Vertex& v) {
  long sv = i.setf(ios::skipws);
  
  char tmp;
  
  i >> tmp;
  
  if (tmp < 'I')
    v.x = tmp - 'A';
  else 
    v.x = tmp - 'B';
    
  int tmp2;
  
  i >> tmp2;
  
  v.y = tmp2 - 1;
  
  i.flags(sv);
  
  return i;    
}
